diff --git a/drupal7/sites/all/modules/views/tests/handlers/views_handler_field_date.test b/drupal7/sites/all/modules/views/tests/handlers/views_handler_field_date.test
index 028b687f..79441429 100644
--- a/drupal7/sites/all/modules/views/tests/handlers/views_handler_field_date.test
+++ b/drupal7/sites/all/modules/views/tests/handlers/views_handler_field_date.test
@@ -34,6 +34,8 @@ class ViewsHandlerFieldDateTest extends ViewsSqlTest {
         'relationship' => 'none',
         // c is iso 8601 date format @see http://php.net/manual/en/function.date.php
         'custom_date_format' => 'c',
+        'second_date_format' => 'custom',
+        'second_date_format_custom' => 'c',
       ),
     ));
     $time = gmmktime(0, 0, 0, 1, 1, 2000);
@@ -51,6 +53,8 @@ class ViewsHandlerFieldDateTest extends ViewsSqlTest {
         'medium' => format_date($time, 'medium', '', $timezone),
         'large' => format_date($time, 'large', '', $timezone),
         'custom' => format_date($time, 'custom', 'c', $timezone),
+        'today time ago custom' => format_date($time, 'custom', 'c', $timezone),
+        'today time ago' => t('%time ago', array('%time' => format_interval(120, 2))),
       );
       $this->assertRenderedDatesEqual($view, $dates, $timezone);
     }
@@ -67,6 +71,17 @@ class ViewsHandlerFieldDateTest extends ViewsSqlTest {
 
   protected function assertRenderedDatesEqual($view, $map, $timezone = NULL) {
     foreach ($map as $date_format => $expected_result) {
+      $check_result_number = 0;
+
+      // If it's "today time ago" format we have to check the 6th element.
+      if ($date_format == 'today time ago') {
+        $check_result_number = 5;
+      }
+
+      // Correct the date format.
+      if ($date_format == 'today time ago custom') {
+        $date_format = 'today time ago';
+      }
       $view->field['created']->options['date_format'] = $date_format;
       $t_args = array(
         '%value' => $expected_result,
@@ -80,8 +95,23 @@ class ViewsHandlerFieldDateTest extends ViewsSqlTest {
       else {
         $message = t('Value %value in %format format matches.', $t_args);
       }
-      $actual_result = $view->field['created']->advanced_render($view->result[0]);
+      $actual_result = $view->field['created']->advanced_render($view->result[$check_result_number]);
       $this->assertEqual($expected_result, $actual_result, $message);
     }
   }
+
+  /**
+   * Appends dataSet() with a data row for "today time ago" format testing.
+   */
+  protected function dataSet() {
+    $data = parent::dataSet();
+    $data[] = array(
+      'name' => 'David',
+      'age' => 25,
+      'job' => 'Singer',
+      'created' => REQUEST_TIME - 120,
+    );
+
+    return $data;
+  }
 }
diff --git a/drupal7/sites/all/modules/views/tests/handlers/views_handler_field_file_extension.test b/drupal7/sites/all/modules/views/tests/handlers/views_handler_field_file_extension.test
new file mode 100644
index 00000000..ab8b0a93
--- /dev/null
+++ b/drupal7/sites/all/modules/views/tests/handlers/views_handler_field_file_extension.test
@@ -0,0 +1,66 @@
+<?php
+
+/**
+ * @file
+ * Definition of ViewsHandlerFileExtensionTest.
+ */
+
+/**
+ * Tests the views_handler_field_file_extension handler.
+ */
+class ViewsHandlerFileExtensionTest extends ViewsSqlTest {
+  public static function getInfo() {
+    return array(
+      'name' => 'Field: File extension',
+      'description' => 'Test the views_handler_field_file_extension handler.',
+      'group' => 'Views Handlers',
+    );
+  }
+
+  function dataSet() {
+    $data = parent::dataSet();
+    $data[0]['name'] = 'file.png';
+    $data[1]['name'] = 'file.tar';
+    $data[2]['name'] = 'file.tar.gz';
+    $data[3]['name'] = 'file';
+
+    return $data;
+  }
+
+  function viewsData() {
+    $data = parent::viewsData();
+    $data['views_test']['name']['field']['handler'] = 'views_handler_field_file_extension';
+    $data['views_test']['name']['real field'] = 'name';
+
+    return $data;
+  }
+
+  /**
+   * Tests the 'extension_detect_tar' handler option.
+   */
+  public function testFileExtensionTarOption() {
+    $view = $this->getBasicView();
+
+    $view->display['default']->handler->override_option('fields', array(
+      'name' => array(
+        'id' => 'name',
+        'table' => 'views_test',
+        'field' => 'name',
+      ),
+    ));
+
+    $this->executeView($view);
+
+    // Test without the tar option.
+    $this->assertEqual($view->field['name']->advanced_render($view->result[0]), 'png');
+    $this->assertEqual($view->field['name']->advanced_render($view->result[1]), 'tar');
+    $this->assertEqual($view->field['name']->advanced_render($view->result[2]), 'gz');
+    $this->assertEqual($view->field['name']->advanced_render($view->result[3]), '');
+    // Test with the tar option.
+    $view->field['name']->options['extension_detect_tar'] = TRUE;
+    $this->assertEqual($view->field['name']->advanced_render($view->result[0]), 'png');
+    $this->assertEqual($view->field['name']->advanced_render($view->result[1]), 'tar');
+    $this->assertEqual($view->field['name']->advanced_render($view->result[2]), 'tar.gz');
+    $this->assertEqual($view->field['name']->advanced_render($view->result[3]), '');
+  }
+}
diff --git a/drupal7/sites/all/modules/views/tests/handlers/views_handlers.test b/drupal7/sites/all/modules/views/tests/handlers/views_handlers.test
new file mode 100644
index 00000000..f2faee3f
--- /dev/null
+++ b/drupal7/sites/all/modules/views/tests/handlers/views_handlers.test
@@ -0,0 +1,81 @@
+<?php
+
+/**
+ * @file
+ * Contains ViewsHandlerTest.
+ */
+
+/**
+ * Tests generic handler functionality.
+ *
+ * @see view
+ */
+class ViewsHandlerTest extends ViewsSqlTest {
+
+  public static function getInfo() {
+    return array(
+      'name' => 'Handlers',
+      'description' => 'Tests generic handler functionality.',
+      'group' => 'Views Handlers',
+    );
+  }
+
+  /**
+   * {@inheritdoc}
+   */
+  protected function viewsData() {
+    $views_data = parent::viewsData();
+    $views_data['views']['test_access'] = array(
+      'title' => 'test access',
+      'help' => '',
+      'area' => array(
+        'handler' => 'views_test_area_access',
+      ),
+    );
+
+    return $views_data;
+  }
+
+  /**
+   * Tests access for handlers using an area handler.
+   */
+  public function testHandlerAccess() {
+    $view = $this->getBasicView();
+
+    // add a test area
+    $view->display['default']->handler->override_option('header', array(
+      'test_access' => array(
+        'id' => 'test_access',
+        'table' => 'views',
+        'field' => 'test_access',
+        'custom_access' => FALSE,
+      ),
+    ));
+
+    $view->init_display();
+    $view->init_handlers();
+    $handlers = $view->display_handler->get_handlers('header');
+    $this->assertEqual(0, count($handlers));
+
+    $view->destroy();
+
+    $view = $this->getBasicView();
+
+    // add a test area
+    $view->display['default']->handler->override_option('header', array(
+      'test_access' => array(
+        'id' => 'test_access',
+        'table' => 'views',
+        'field' => 'test_access',
+        'custom_access' => TRUE,
+      ),
+    ));
+
+    $view->init_display();
+    $view->init_handlers();
+    $handlers = $view->display_handler->get_handlers('header');
+    $this->assertEqual(1, count($handlers));
+    $this->assertTrue(isset($handlers['test_access']));
+  }
+
+}
diff --git a/drupal7/sites/all/modules/views/tests/test_handlers/views_test_area_access.inc b/drupal7/sites/all/modules/views/tests/test_handlers/views_test_area_access.inc
new file mode 100644
index 00000000..57a0014e
--- /dev/null
+++ b/drupal7/sites/all/modules/views/tests/test_handlers/views_test_area_access.inc
@@ -0,0 +1,28 @@
+<?php
+
+/**
+ * @file
+ * Contains views_test_area_access
+ */
+
+class views_test_area_access extends views_handler_area {
+
+  /**
+   * {@inheritdoc}
+   */
+  function access() {
+    return $this->options['custom_access'];
+ }
+
+  /**
+   * {@inheritdoc}
+   */
+  function option_definition() {
+    $options = parent::option_definition();
+
+    $options['custom_access'] = array('default' => TRUE, 'bool' => TRUE);
+
+    return $options;
+  }
+
+}
diff --git a/drupal7/sites/all/modules/views/tests/views_cache.test b/drupal7/sites/all/modules/views/tests/views_cache.test
index 31037623..28534a2f 100644
--- a/drupal7/sites/all/modules/views/tests/views_cache.test
+++ b/drupal7/sites/all/modules/views/tests/views_cache.test
@@ -241,4 +241,68 @@ class ViewsCacheTest extends ViewsSqlTest {
     $this->assertEqual($first_content_type, $second_content_type, t('Content types of responses are equal.'));
   }
 
+  /**
+   * Test caching of different exposed filter values with the same view result.
+   *
+   * Make sure the output is different.
+   */
+  function testExposedFilterSameResultsCaching() {
+    // Create the view with time-based cache with hour lifetimes and add exposed
+    // filter to it with "Starts with" operator.
+    $view = $this->getBasicView();
+    $view->set_display();
+    $view->display_handler->override_option('cache', array(
+      'type' => 'time',
+      'results_lifespan' => '3600',
+      'output_lifespan' => '3600',
+    ));
+    $view->display_handler->override_option('filters', array(
+      'name' => array(
+        'id' => 'name',
+        'table' => 'views_test',
+        'field' => 'name',
+        'relationship' => 'none',
+        'operator' => 'starts',
+        'exposed' => TRUE,
+        'expose' => array(
+          'operator_id' => 'name_op',
+          'operator' => 'name_op',
+          'identifier' => 'name',
+        ),
+      ),
+    ));
+
+    // Clone the view before setting exposed input.
+    $clone = $view->copy();
+
+    // Pass "Rin" to the exposed filter and check that only one row returned.
+    $view->set_exposed_input(array(
+      'name' => 'Rin',
+    ));
+    $this->executeView($view);
+    $first_result = $view->result;
+    $first_output = $view->render();
+    $this->assertEqual(1, count($first_result), t('The number of rows returned by the first view match.'));
+
+    // Pass full "Ringo" to the exposed filter at the second time and make sure
+    // results are the same.
+    $clone->set_exposed_input(array(
+      'name' => 'Ringo',
+    ));
+    $this->executeView($clone);
+    $second_result = $clone->result;
+    $second_output = $clone->render();
+    $this->assertEqual($first_result, $second_result, t('Results of both views are the same.'));
+
+    // Check that output is not the same and it contains full "Ringo" word in
+    // default value of exposed input.
+    $this->assertNotEqual($first_output, $second_output, t('Output of the second view is different.'));
+    $this->drupalSetContent($second_output);
+    $element = $this->xpath('//input[@name="name" and @value="Ringo"]');
+    $this->assertTrue(!empty($element), t('Input field of exposed filter has the second value.'));
+
+    $view->destroy();
+    $clone->destroy();
+  }
+
 }
diff --git a/drupal7/sites/all/modules/views/tests/views_module.test b/drupal7/sites/all/modules/views/tests/views_module.test
index dc6c1640..6a27443a 100644
--- a/drupal7/sites/all/modules/views/tests/views_module.test
+++ b/drupal7/sites/all/modules/views/tests/views_module.test
@@ -151,6 +151,51 @@ class ViewsModuleTest extends ViewsSqlTest {
     $this->assertEqual('views_handler_filter', get_class($handler));
   }
 
+  /**
+   * Tests views_fetch_data().
+   */
+  function testFetchData() {
+
+    // Make sure we start with a empty cache.
+    $this->resetStaticViewsDataCache();
+    cache_clear_all('*', 'cache_views', TRUE);
+    variable_set('views_test_views_data_count', 0);
+
+    // Request info about an existing table.
+    $this->assertTrue(views_fetch_data('views_test'), 'Data about existing table returned');
+    // This should have triggered a views data rebuild, and written a cache
+    // entry for all tables and the requested table but no other tables.
+    $this->assertEqual(variable_get('views_test_views_data_count', 0), 1, 'Views data rebuilt once');
+    $this->assertTrue(cache_get('views_data:en', 'cache_views'), 'Cache for all tables written.');
+    $this->assertTrue(cache_get('views_data:views_test:en', 'cache_views'), 'Cache for requested table written.');
+    $this->assertFalse(cache_get('views_data:views_test_previous:en', 'cache_views'), 'No Cache written for not requested table.');
+    $this->assertTrue(drupal_static('_views_fetch_data_fully_loaded'), 'Views data is fully loaded');
+
+    $this->resetStaticViewsDataCache();
+
+    // Request the same table again.
+    $this->assertTrue(views_fetch_data('views_test'), 'Data about existing table returned');
+    $this->assertEqual(variable_get('views_test_views_data_count', 0), 1, 'Views data rebuilt once');
+    $this->assertFalse(drupal_static('_views_fetch_data_fully_loaded'), 'Views data is not fully loaded');
+
+    $this->resetStaticViewsDataCache();
+
+    // Request a missing table, this should load the full cache from cache but
+    // not rebuilt.
+    $this->assertFalse(views_fetch_data('views_test_missing'), 'No data about missing table returned');
+    $this->assertEqual(variable_get('views_test_views_data_count', 0), 1, 'Views data rebuilt once');
+    $this->assertTrue(drupal_static('_views_fetch_data_fully_loaded'), 'Views data is fully loaded');
+
+    $this->resetStaticViewsDataCache();
+
+    // Request the same empty table again, this should load only that (empty)
+    // cache for that table.
+    $this->assertFalse(views_fetch_data('views_test_missing'), 'No data about missing table returned');
+    $this->assertEqual(variable_get('views_test_views_data_count', 0), 1, 'Views data rebuilt once');
+    $this->assertFalse(drupal_static('_views_fetch_data_fully_loaded'), 'Views data is not fully loaded');
+
+  }
+
   /**
    * Ensure that a certain handler is a instance of a certain table/field.
    */
@@ -160,4 +205,13 @@ class ViewsModuleTest extends ViewsSqlTest {
 
     $this->assertEqual($field_data['handler'], get_class($handler));
   }
+
+  /**
+   * Resets the views data cache.
+   */
+  protected function resetStaticViewsDataCache() {
+    drupal_static_reset('_views_fetch_data_cache');
+    drupal_static_reset('_views_fetch_data_recursion_protected');
+    drupal_static_reset('_views_fetch_data_fully_loaded');
+  }
 }
diff --git a/drupal7/sites/all/modules/views/tests/views_test.info b/drupal7/sites/all/modules/views/tests/views_test.info
index 23bd884f..e0256dc4 100644
--- a/drupal7/sites/all/modules/views/tests/views_test.info
+++ b/drupal7/sites/all/modules/views/tests/views_test.info
@@ -5,9 +5,9 @@ core = 7.x
 dependencies[] = views
 hidden = TRUE
 
-; Information added by drupal.org packaging script on 2013-04-09
-version = "7.x-3.7"
+; Information added by Drupal.org packaging script on 2014-05-20
+version = "7.x-3.8"
 core = "7.x"
 project = "views"
-datestamp = "1365499236"
+datestamp = "1400618928"
 
diff --git a/drupal7/sites/all/modules/views/tests/views_test.module b/drupal7/sites/all/modules/views/tests/views_test.module
index 7adcf430..a7460690 100644
--- a/drupal7/sites/all/modules/views/tests/views_test.module
+++ b/drupal7/sites/all/modules/views/tests/views_test.module
@@ -31,6 +31,10 @@ function views_test_views_api() {
  * Implements hook_views_data().
  */
 function views_test_views_data() {
+  // Count how often this hook is called.
+  $count = variable_get('views_test_views_data_count', 0);
+  $count++;
+  variable_set('views_test_views_data_count', $count);
   return  variable_get('views_test_views_data', array());
 }
 
diff --git a/drupal7/sites/all/modules/views/views.api.php b/drupal7/sites/all/modules/views/views.api.php
index ba9b326f..07cd76cf 100644
--- a/drupal7/sites/all/modules/views/views.api.php
+++ b/drupal7/sites/all/modules/views/views.api.php
@@ -513,6 +513,80 @@ function hook_views_data_alter(&$data) {
   // Note that the $data array is not returned – it is modified by reference.
 }
 
+/**
+ * Override the default data for a Field API field.
+ *
+ * Field module's implementation of hook_views_data() invokes this for each
+ * field in the module that defines the field type (as declared in the field
+ * array). It is not invoked in other modules.
+ *
+ * If no hook implementation exists, hook_views_data() falls back to
+ * field_views_field_default_views_data().
+ *
+ * @see field_views_data()
+ * @see hook_field_views_data_alter()
+ * @see hook_field_views_data_views_data_alter()
+ *
+ * @param $field
+ *  A field definition array, as returned by field_info_fields().
+ *
+ * @return
+ *  An array of views data, in the same format as the return value of
+ *  hook_views_data().
+ */
+function hook_field_views_data($field) {
+
+}
+
+/**
+ * Alter the views data for a single Field API field.
+ *
+ * This is called even if there is no hook_field_views_data() implementation for
+ * the field, and therefore may be used to alter the default data that
+ * field_views_field_default_views_data() supplies for the field.
+ *
+ * @param $result
+ *  An array of views table data provided for a single field. This has the same
+ *  format as the return value of hook_views_data().
+ * @param $field
+ *  A field definition array, as returned by field_info_fields().
+ * @param $module
+ *  The module that defines the field type.
+ *
+ * @see field_views_data()
+ * @see hook_field_views_data()
+ * @see hook_field_views_data_views_data_alter()
+ */
+function hook_field_views_data_alter(&$result, $field, $module) {
+
+}
+
+/**
+ * Alter the views data on a per field basis.
+ *
+ * Field module's implementation of hook_views_data_alter() invokes this for
+ * each field in the module that defines the field type (as declared in the
+ * field array). It is not invoked in other modules.
+ *
+ * Unlike hook_field_views_data_alter(), this operates on the whole of the views
+ * data. This allows a field module to add data that concerns its fields to
+ * other tables, which would not yet be defined at the point when
+ * hook_field_views_data() and hook_field_views_data_alter() are invoked. For
+ * example, entityreference adds reverse relationships on the tables for the
+ * entities which are referenced by entityreference fields.
+ *
+ * (Note: this is weirdly named so as not to conflict with
+ * hook_field_views_data_alter().)
+ *
+ * @see hook_field_views_data()
+ * @see hook_field_views_data_alter()
+ * @see field_views_data_alter()
+ */
+function hook_field_views_data_views_data_alter(&$data, $field) {
+  $field_name = $field['field_name'];
+  $data_key = 'field_data_' . $field_name;
+  // Views data for this field is in $data[$data_key]
+}
 
 /**
  * Describes plugins defined by the module.
diff --git a/drupal7/sites/all/modules/views/views.info b/drupal7/sites/all/modules/views/views.info
index 50d81482..50f939c6 100644
--- a/drupal7/sites/all/modules/views/views.info
+++ b/drupal7/sites/all/modules/views/views.info
@@ -10,6 +10,7 @@ stylesheets[all][] = css/views.css
 dependencies[] = ctools
 ; Handlers
 files[] = handlers/views_handler_area.inc
+files[] = handlers/views_handler_area_messages.inc
 files[] = handlers/views_handler_area_result.inc
 files[] = handlers/views_handler_area_text.inc
 files[] = handlers/views_handler_area_text_custom.inc
@@ -49,6 +50,7 @@ files[] = handlers/views_handler_filter_in_operator.inc
 files[] = handlers/views_handler_filter_many_to_one.inc
 files[] = handlers/views_handler_filter_numeric.inc
 files[] = handlers/views_handler_filter_string.inc
+files[] = handlers/views_handler_filter_fields_compare.inc
 files[] = handlers/views_handler_relationship.inc
 files[] = handlers/views_handler_relationship_groupwise_max.inc
 files[] = handlers/views_handler_sort.inc
@@ -253,6 +255,7 @@ files[] = plugins/views_plugin_style_summary_unformatted.inc
 files[] = plugins/views_plugin_style_table.inc
 
 ; Tests
+files[] = tests/handlers/views_handlers.test
 files[] = tests/handlers/views_handler_area_text.test
 files[] = tests/handlers/views_handler_argument_null.test
 files[] = tests/handlers/views_handler_argument_string.test
@@ -261,6 +264,7 @@ files[] = tests/handlers/views_handler_field_boolean.test
 files[] = tests/handlers/views_handler_field_custom.test
 files[] = tests/handlers/views_handler_field_counter.test
 files[] = tests/handlers/views_handler_field_date.test
+files[] = tests/handlers/views_handler_field_file_extension.test
 files[] = tests/handlers/views_handler_field_file_size.test
 files[] = tests/handlers/views_handler_field_math.test
 files[] = tests/handlers/views_handler_field_url.test
@@ -274,6 +278,7 @@ files[] = tests/handlers/views_handler_filter_string.test
 files[] = tests/handlers/views_handler_sort_random.test
 files[] = tests/handlers/views_handler_sort_date.test
 files[] = tests/handlers/views_handler_sort.test
+files[] = tests/test_handlers/views_test_area_access.inc
 files[] = tests/test_plugins/views_test_plugin_access_test_dynamic.inc
 files[] = tests/test_plugins/views_test_plugin_access_test_static.inc
 files[] = tests/test_plugins/views_test_plugin_style_test_mapping.inc
@@ -312,9 +317,9 @@ files[] = tests/views_cache.test
 files[] = tests/views_view.test
 files[] = tests/views_ui.test
 
-; Information added by drupal.org packaging script on 2013-04-09
-version = "7.x-3.7"
+; Information added by Drupal.org packaging script on 2014-05-20
+version = "7.x-3.8"
 core = "7.x"
 project = "views"
-datestamp = "1365499236"
+datestamp = "1400618928"
 
diff --git a/drupal7/sites/all/modules/views/views.module b/drupal7/sites/all/modules/views/views.module
index fc427f49..20258df7 100644
--- a/drupal7/sites/all/modules/views/views.module
+++ b/drupal7/sites/all/modules/views/views.module
@@ -355,9 +355,6 @@ function views_permission() {
  * Implement hook_menu().
  */
 function views_menu() {
-  // Any event which causes a menu_rebuild could potentially mean that the
-  // Views data is updated -- module changes, profile changes, etc.
-  views_invalidate_cache();
   $items = array();
   $items['views/ajax'] = array(
     'title' => 'Views',
diff --git a/drupal7/sites/all/modules/views/views_ui.info b/drupal7/sites/all/modules/views/views_ui.info
index 95ea0149..d7c8c255 100644
--- a/drupal7/sites/all/modules/views/views_ui.info
+++ b/drupal7/sites/all/modules/views/views_ui.info
@@ -7,9 +7,9 @@ dependencies[] = views
 files[] = views_ui.module
 files[] = plugins/views_wizard/views_ui_base_views_wizard.class.php
 
-; Information added by drupal.org packaging script on 2013-04-09
-version = "7.x-3.7"
+; Information added by Drupal.org packaging script on 2014-05-20
+version = "7.x-3.8"
 core = "7.x"
 project = "views"
-datestamp = "1365499236"
+datestamp = "1400618928"
 
